diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/onoff-application.h ns-3.47/src/applications/model/onoff-application.h
--- ns-3.46/src/applications/model/onoff-application.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/onoff-application.h	2026-02-16 16:08:49.570229800 -0800
@@ -26,7 +26,6 @@
 {
 
 class RandomVariableStream;
-class Socket;
 
 /**
  * @ingroup applications
@@ -103,26 +102,12 @@
      */
     void SetMaxBytes(uint64_t maxBytes);
 
-    /**
-     * @brief Return a pointer to associated socket.
-     * @return pointer to associated socket
-     */
-    Ptr<Socket> GetSocket() const;
-
     int64_t AssignStreams(int64_t stream) override;
 
-  protected:
-    void DoDispose() override;
-
   private:
-    void StartApplication() override;
-    void StopApplication() override;
-
-    // helpers
-    /**
-     * @brief Cancel all pending events.
-     */
-    void CancelEvents();
+    void DoStartApplication() override;
+    void DoConnectionSucceeded(Ptr<Socket> socket) override;
+    void CancelEvents() override;
 
     // Event handlers
     /**
@@ -137,28 +122,34 @@
      * @brief Send a packet
      */
     void SendPacket();
+    /**
+     * @brief Schedule the next packet transmission
+     */
+    void ScheduleNextTx();
+    /**
+     * @brief Schedule the next On period start
+     */
+    void ScheduleStartEvent();
+    /**
+     * @brief Schedule the next Off period start
+     */
+    void ScheduleStopEvent();
 
-    Ptr<Socket> m_socket;                //!< Associated socket
-    bool m_connected;                    //!< True if connected
     Ptr<RandomVariableStream> m_onTime;  //!< rng for On Time
     Ptr<RandomVariableStream> m_offTime; //!< rng for Off Time
     DataRate m_cbrRate;                  //!< Rate that data is generated
     DataRate m_cbrRateFailSafe;          //!< Rate that data is generated (check copy)
     uint32_t m_pktSize;                  //!< Size of packets
-    uint32_t m_residualBits;             //!< Number of generated, but not sent, bits
+    uint32_t m_residualBits{0};          //!< Number of generated, but not sent, bits
     Time m_lastStartTime;                //!< Time last packet sent
     uint64_t m_maxBytes;                 //!< Limit total number of bytes sent
-    uint64_t m_totBytes;                 //!< Total bytes sent so far
+    uint64_t m_totBytes{0};              //!< Total bytes sent so far
     EventId m_startStopEvent;            //!< Event id for next start or stop event
     EventId m_sendEvent;                 //!< Event id of pending "send packet" event
-    TypeId m_tid;                        //!< Type of the socket used
     uint32_t m_seq{0};                   //!< Sequence
     Ptr<Packet> m_unsentPacket;          //!< Unsent packet cached for future attempt
     bool m_enableSeqTsSizeHeader{false}; //!< Enable or disable the use of SeqTsSizeHeader
 
-    /// Traced Callback: transmitted packets.
-    TracedCallback<Ptr<const Packet>> m_txTrace;
-
     /// Callbacks for tracing the packet Tx events, includes source and destination addresses
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_txTraceWithAddresses;
 
@@ -167,30 +158,6 @@
     TracedCallback<Ptr<const Packet>, const Address&, const Address&, const SeqTsSizeHeader&>
         m_txTraceWithSeqTsSize;
 
-  private:
-    /**
-     * @brief Schedule the next packet transmission
-     */
-    void ScheduleNextTx();
-    /**
-     * @brief Schedule the next On period start
-     */
-    void ScheduleStartEvent();
-    /**
-     * @brief Schedule the next Off period start
-     */
-    void ScheduleStopEvent();
-    /**
-     * @brief Handle a Connection Succeed event
-     * @param socket the connected socket
-     */
-    void ConnectionSucceeded(Ptr<Socket> socket);
-    /**
-     * @brief Handle a Connection Failed event
-     * @param socket the not connected socket
-     */
-    void ConnectionFailed(Ptr<Socket> socket);
-
     TracedValue<bool> m_state; //!< State of application (0-OFF, 1-ON)
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/packet-loss-counter.cc ns-3.47/src/applications/model/packet-loss-counter.cc
--- ns-3.46/src/applications/model/packet-loss-counter.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/packet-loss-counter.cc	2026-02-16 16:08:49.570229800 -0800
@@ -19,10 +19,6 @@
 NS_LOG_COMPONENT_DEFINE("PacketLossCounter");
 
 PacketLossCounter::PacketLossCounter(uint8_t bitmapSize)
-    : m_lost(0),
-      m_bitMapSize(0),
-      m_lastMaxSeqNum(0),
-      m_receiveBitMap(nullptr)
 {
     NS_LOG_FUNCTION(this << bitmapSize);
     SetBitMapSize(bitmapSize);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/packet-loss-counter.h ns-3.47/src/applications/model/packet-loss-counter.h
--- ns-3.46/src/applications/model/packet-loss-counter.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/packet-loss-counter.h	2026-02-16 16:08:49.570229800 -0800
@@ -76,10 +76,10 @@
      */
     void SetBit(uint32_t seqNum, bool val);
 
-    uint32_t m_lost;          //!< Lost packets counter.
-    uint16_t m_bitMapSize;    //!< Window size.
-    uint32_t m_lastMaxSeqNum; //!< Last sequence number seen.
-    uint8_t* m_receiveBitMap; //!< Received packets in the window size.
+    uint32_t m_lost{0};                //!< Lost packets counter.
+    uint16_t m_bitMapSize{0};          //!< Window size.
+    uint32_t m_lastMaxSeqNum{0};       //!< Last sequence number seen.
+    uint8_t* m_receiveBitMap{nullptr}; //!< Received packets in the window size.
 };
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/packet-sink.cc ns-3.47/src/applications/model/packet-sink.cc
--- ns-3.46/src/applications/model/packet-sink.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/packet-sink.cc	2026-02-16 16:08:49.570229800 -0800
@@ -42,17 +42,13 @@
             .AddAttribute("Protocol",
                           "The type id of the protocol to use for the rx socket.",
                           TypeIdValue(UdpSocketFactory::GetTypeId()),
-                          MakeTypeIdAccessor(&PacketSink::m_tid),
+                          MakeTypeIdAccessor(&PacketSink::m_protocolTid),
                           MakeTypeIdChecker())
             .AddAttribute("EnableSeqTsSizeHeader",
                           "Enable optional header tracing of SeqTsSizeHeader",
                           BooleanValue(false),
                           MakeBooleanAccessor(&PacketSink::m_enableSeqTsSizeHeader),
                           MakeBooleanChecker())
-            .AddTraceSource("Rx",
-                            "A packet has been received",
-                            MakeTraceSourceAccessor(&PacketSink::m_rxTrace),
-                            "ns3::Packet::AddressTracedCallback")
             .AddTraceSource("RxWithAddresses",
                             "A packet has been received",
                             MakeTraceSourceAccessor(&PacketSink::m_rxTraceWithAddresses),
@@ -65,12 +61,6 @@
 }
 
 PacketSink::PacketSink()
-    : m_buffer{},
-      m_socket{nullptr},
-      m_socket6{nullptr},
-      m_socketList{},
-      m_totalRx{0},
-      m_enableSeqTsSizeHeader{false}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -105,74 +95,63 @@
 PacketSink::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    m_socket = nullptr;
     m_socketList.clear();
 
     // chain up
-    Application::DoDispose();
+    SinkApplication::DoDispose();
 }
 
 // Application Methods
 void
-PacketSink::StartApplication() // Called at time specified by Start
+PacketSink::DoStartApplication() // Called at time specified by Start
 {
     NS_LOG_FUNCTION(this);
 
-    // Create the socket if not already
-    if (!m_socket)
+    auto local = m_local;
+    if (local.IsInvalid())
     {
-        m_socket = Socket::CreateSocket(GetNode(), m_tid);
-        auto local = m_local;
-        if (local.IsInvalid())
-        {
-            local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
-            NS_LOG_INFO(this << " Binding on port " << m_port << " / " << local << ".");
-        }
-        else if (InetSocketAddress::IsMatchingType(local))
-        {
-            m_port = InetSocketAddress::ConvertFrom(local).GetPort();
-            const auto ipv4 = InetSocketAddress::ConvertFrom(local).GetIpv4();
-            NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << local
-                             << ".");
-        }
-        else if (Inet6SocketAddress::IsMatchingType(local))
-        {
-            m_port = Inet6SocketAddress::ConvertFrom(local).GetPort();
-            const auto ipv6 = Inet6SocketAddress::ConvertFrom(local).GetIpv6();
-            NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << local
-                             << ".");
-        }
-        if (m_socket->Bind(local) == -1)
+        local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+        NS_LOG_INFO(this << " Binding on port " << m_port << " / " << local << ".");
+    }
+    else if (InetSocketAddress::IsMatchingType(local))
+    {
+        m_port = InetSocketAddress::ConvertFrom(local).GetPort();
+        const auto ipv4 = InetSocketAddress::ConvertFrom(local).GetIpv4();
+        NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << local << ".");
+    }
+    else if (Inet6SocketAddress::IsMatchingType(local))
+    {
+        m_port = Inet6SocketAddress::ConvertFrom(local).GetPort();
+        const auto ipv6 = Inet6SocketAddress::ConvertFrom(local).GetIpv6();
+        NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << local << ".");
+    }
+    if (m_socket->Bind(local) == -1)
+    {
+        NS_FATAL_ERROR("Failed to bind socket");
+    }
+    m_socket->Listen();
+    m_socket->ShutdownSend();
+    if (addressUtils::IsMulticast(local))
+    {
+        if (auto udpSocket = DynamicCast<UdpSocket>(m_socket))
         {
-            NS_FATAL_ERROR("Failed to bind socket");
+            // equivalent to setsockopt (MCAST_JOIN_GROUP)
+            udpSocket->MulticastJoinGroup(0, local);
         }
-        m_socket->Listen();
-        m_socket->ShutdownSend();
-        if (addressUtils::IsMulticast(local))
+        else
         {
-            if (auto udpSocket = DynamicCast<UdpSocket>(m_socket))
-            {
-                // equivalent to setsockopt (MCAST_JOIN_GROUP)
-                udpSocket->MulticastJoinGroup(0, local);
-            }
-            else
-            {
-                NS_FATAL_ERROR("Error: joining multicast on a non-UDP socket");
-            }
+            NS_FATAL_ERROR("Error: joining multicast on a non-UDP socket");
         }
-        m_socket->SetRecvCallback(MakeCallback(&PacketSink::HandleRead, this));
-        m_socket->SetRecvPktInfo(true);
-        m_socket->SetAcceptCallback(MakeNullCallback<bool, Ptr<Socket>, const Address&>(),
-                                    MakeCallback(&PacketSink::HandleAccept, this));
-        m_socket->SetCloseCallbacks(MakeCallback(&PacketSink::HandlePeerClose, this),
-                                    MakeCallback(&PacketSink::HandlePeerError, this));
     }
+    m_socket->SetRecvCallback(MakeCallback(&PacketSink::HandleRead, this));
+    m_socket->SetRecvPktInfo(true);
+    m_socket->SetAcceptCallback(MakeNullCallback<bool, Ptr<Socket>, const Address&>(),
+                                MakeCallback(&PacketSink::HandleAccept, this));
+    m_socket->SetCloseCallbacks(MakeCallback(&PacketSink::HandlePeerClose, this),
+                                MakeCallback(&PacketSink::HandlePeerError, this));
 
-    if (m_local.IsInvalid() && !m_socket6)
-    {
-        // local address is not specified, so create another socket to also listen to all IPv6
-        // addresses
-        m_socket6 = Socket::CreateSocket(GetNode(), m_tid);
+    if (m_local.IsInvalid())
+    {
         auto local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
         if (m_socket6->Bind(local) == -1)
         {
@@ -202,7 +181,7 @@
 }
 
 void
-PacketSink::StopApplication() // Called at time specified by Stop
+PacketSink::DoStopApplication() // Called at time specified by Stop
 {
     NS_LOG_FUNCTION(this);
     while (!m_socketList.empty()) // these are accepted sockets, close them
@@ -211,16 +190,6 @@
         m_socketList.pop_front();
         acceptedSocket->Close();
     }
-    if (m_socket)
-    {
-        m_socket->Close();
-        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
-    if (m_socket6)
-    {
-        m_socket6->Close();
-        m_socket6->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    }
 }
 
 void
@@ -252,7 +221,8 @@
                                    << " total Rx " << m_totalRx << " bytes");
         }
 
-        if (!m_rxTrace.IsEmpty() || !m_rxTraceWithAddresses.IsEmpty() ||
+        if (!m_rxTrace.IsEmpty() || !m_rxTraceWithoutAddress.IsEmpty() ||
+            !m_rxTraceWithAddresses.IsEmpty() ||
             (!m_rxTraceWithSeqTsSize.IsEmpty() && m_enableSeqTsSizeHeader))
         {
             Address localAddress;
@@ -270,6 +240,7 @@
             {
                 socket->GetSockName(localAddress);
             }
+            m_rxTraceWithoutAddress(packet);
             m_rxTrace(packet, from);
             m_rxTraceWithAddresses(packet, from, localAddress);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/packet-sink.h ns-3.47/src/applications/model/packet-sink.h
--- ns-3.46/src/applications/model/packet-sink.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/packet-sink.h	2026-02-16 16:08:49.570229800 -0800
@@ -23,7 +23,6 @@
 namespace ns3
 {
 
-class Socket;
 class Packet;
 
 /**
@@ -102,8 +101,8 @@
     void DoDispose() override;
 
   private:
-    void StartApplication() override;
-    void StopApplication() override;
+    void DoStartApplication() override;
+    void DoStopApplication() override;
 
     /**
      * @brief Handle a packet received by the application
@@ -159,12 +158,12 @@
             if (InetSocketAddress::IsMatchingType(x))
             {
                 InetSocketAddress a = InetSocketAddress::ConvertFrom(x);
-                return Ipv4AddressHash()(a.GetIpv4());
+                return std::hash<Ipv4Address>{}(a.GetIpv4());
             }
             else if (Inet6SocketAddress::IsMatchingType(x))
             {
                 Inet6SocketAddress a = Inet6SocketAddress::ConvertFrom(x);
-                return Ipv6AddressHash()(a.GetIpv6());
+                return std::hash<Ipv6Address>{}(a.GetIpv6());
             }
 
             NS_ABORT_MSG("PacketSink: unexpected address type, neither IPv4 nor IPv6");
@@ -174,20 +173,14 @@
 
     std::unordered_map<Address, Ptr<Packet>, AddressHash> m_buffer; //!< Buffer for received packets
 
-    Ptr<Socket> m_socket;  //!< Socket
-    Ptr<Socket> m_socket6; //!< IPv6 Socket (used if only port is specified)
-
     // In the case of TCP, each socket accept returns a new socket, so the
     // listening socket is stored separately from the accepted sockets
     std::list<Ptr<Socket>> m_socketList; //!< the accepted sockets
 
-    uint64_t m_totalRx; //!< Total bytes received
-    TypeId m_tid;       //!< Protocol TypeId
+    uint64_t m_totalRx{0}; //!< Total bytes received
 
-    bool m_enableSeqTsSizeHeader; //!< Enable or disable the export of SeqTsSize header
+    bool m_enableSeqTsSizeHeader{false}; //!< Enable or disable the export of SeqTsSize header
 
-    /// Traced Callback: received packets, source address.
-    TracedCallback<Ptr<const Packet>, const Address&> m_rxTrace;
     /// Callback for tracing the packet Rx events, includes source and destination addresses
     TracedCallback<Ptr<const Packet>, const Address&, const Address&> m_rxTraceWithAddresses;
     /// Callbacks for tracing the packet Rx events, includes source, destination addresses, and
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/rta-tig-mobile-gaming.cc ns-3.47/src/applications/model/rta-tig-mobile-gaming.cc
--- ns-3.46/src/applications/model/rta-tig-mobile-gaming.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/rta-tig-mobile-gaming.cc	2026-02-16 16:08:49.570229800 -0800
@@ -0,0 +1,309 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "rta-tig-mobile-gaming.h"
+
+#include "ns3/double.h"
+#include "ns3/enum.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/inet6-socket-address.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/nstime.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/packet.h"
+#include "ns3/pointer.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/simulator.h"
+#include "ns3/socket-factory.h"
+#include "ns3/socket.h"
+#include "ns3/string.h"
+#include "ns3/udp-socket-factory.h"
+
+#include <cmath>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("RtaTigMobileGaming");
+
+NS_OBJECT_ENSURE_REGISTERED(RtaTigMobileGaming);
+
+TypeId
+RtaTigMobileGaming::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::RtaTigMobileGaming")
+            .SetParent<SourceApplication>()
+            .SetGroupName("Applications")
+            .AddConstructor<RtaTigMobileGaming>()
+            .AddAttribute("ModelPresets",
+                          "The model presets to use (Custom for custom settings)",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
+                          EnumValue(RtaTigMobileGaming::ModelPresets::CUSTOM),
+                          MakeEnumAccessor<ModelPresets>(&RtaTigMobileGaming::m_modelPresets),
+                          MakeEnumChecker(RtaTigMobileGaming::ModelPresets::CUSTOM,
+                                          "Custom",
+                                          RtaTigMobileGaming::ModelPresets::STATUS_SYNC_DL,
+                                          "StatusSyncDl",
+                                          RtaTigMobileGaming::ModelPresets::STATUS_SYNC_UL,
+                                          "StatusSyncUl",
+                                          RtaTigMobileGaming::ModelPresets::LOCKSTEP_DL,
+                                          "LockstepDl",
+                                          RtaTigMobileGaming::ModelPresets::LOCKSTEP_UL,
+                                          "LockstepUl"))
+            .AddAttribute(
+                "Protocol",
+                "The type of protocol to use. This should be a subclass of ns3::SocketFactory",
+                TypeIdValue(UdpSocketFactory::GetTypeId()),
+                MakeTypeIdAccessor(&RtaTigMobileGaming::m_protocolTid),
+                MakeTypeIdChecker())
+            .AddAttribute(
+                "CustomInitialPacketSize",
+                "A uniform random variable to generate size in bytes for initial packet payload.",
+                StringValue("ns3::UniformRandomVariable[Min=0|Max=20]"),
+                MakePointerAccessor(&RtaTigMobileGaming::m_initialSizeUniform),
+                MakePointerChecker<UniformRandomVariable>())
+            .AddAttribute(
+                "CustomEndPacketSize",
+                "A uniform random variable to generate size in bytes for end packet payload.",
+                StringValue("ns3::UniformRandomVariable[Min=500|Max=600]"),
+                MakePointerAccessor(&RtaTigMobileGaming::m_endSizeUniform),
+                MakePointerChecker<UniformRandomVariable>())
+            .AddAttribute(
+                "CustomPacketSizeLev",
+                "A largest extreme value random variable to calculate packet sizes in bytes.",
+                StringValue("ns3::LargestExtremeValueRandomVariable[Location=50|Scale=11.0]"),
+                MakePointerAccessor(&RtaTigMobileGaming::m_levSizes),
+                MakePointerChecker<LargestExtremeValueRandomVariable>())
+            .AddAttribute(
+                "CustomPacketArrivalLev",
+                "A largest extreme value random variable to calculate packet packet arrivals in "
+                "microseconds.",
+                StringValue("ns3::LargestExtremeValueRandomVariable[Location=13000|Scale=3700]"),
+                MakePointerAccessor(&RtaTigMobileGaming::m_levArrivals),
+                MakePointerChecker<LargestExtremeValueRandomVariable>())
+            .AddTraceSource("TxWithStage",
+                            "A packet is sent, this trace also reports the current stage",
+                            MakeTraceSourceAccessor(&RtaTigMobileGaming::m_txStageTrace),
+                            "ns3::RtaTigMobileGaming::TxTracedCallback");
+    return tid;
+}
+
+RtaTigMobileGaming::RtaTigMobileGaming()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+RtaTigMobileGaming::~RtaTigMobileGaming()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+int64_t
+RtaTigMobileGaming::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    auto currentStream = stream;
+    m_initialSizeUniform->SetStream(currentStream++);
+    m_endSizeUniform->SetStream(currentStream++);
+    m_levArrivals->SetStream(currentStream++);
+    m_levSizes->SetStream(currentStream++);
+    return (currentStream - stream);
+}
+
+void
+RtaTigMobileGaming::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+    SourceApplication::DoInitialize();
+
+    if (m_modelPresets != ModelPresets::CUSTOM)
+    {
+        // Load model presets
+        switch (m_modelPresets)
+        {
+        case ModelPresets::STATUS_SYNC_DL:
+            m_initialSizeUniform->SetAttribute("Min", DoubleValue(0));
+            m_initialSizeUniform->SetAttribute("Max", DoubleValue(20));
+            m_endSizeUniform->SetAttribute("Min", DoubleValue(500));
+            m_endSizeUniform->SetAttribute("Max", DoubleValue(600));
+            m_levSizes->SetAttribute("Location", DoubleValue(50.0));
+            m_levSizes->SetAttribute("Scale", DoubleValue(11.0));
+            m_levArrivals->SetAttribute("Location", DoubleValue(13000.0));
+            m_levArrivals->SetAttribute("Scale", DoubleValue(3700.0));
+            break;
+        case ModelPresets::STATUS_SYNC_UL:
+            m_initialSizeUniform->SetAttribute("Min", DoubleValue(0));
+            m_initialSizeUniform->SetAttribute("Max", DoubleValue(20));
+            m_endSizeUniform->SetAttribute("Min", DoubleValue(400));
+            m_endSizeUniform->SetAttribute("Max", DoubleValue(550));
+            m_levSizes->SetAttribute("Location", DoubleValue(38.0));
+            m_levSizes->SetAttribute("Scale", DoubleValue(3.7));
+            m_levArrivals->SetAttribute("Location", DoubleValue(15000.0));
+            m_levArrivals->SetAttribute("Scale", DoubleValue(5700.0));
+            break;
+        case ModelPresets::LOCKSTEP_DL:
+            m_initialSizeUniform->SetAttribute("Min", DoubleValue(0));
+            m_initialSizeUniform->SetAttribute("Max", DoubleValue(80));
+            m_endSizeUniform->SetAttribute("Min", DoubleValue(1400));
+            m_endSizeUniform->SetAttribute("Max", DoubleValue(1500));
+            m_levSizes->SetAttribute("Location", DoubleValue(210.0));
+            m_levSizes->SetAttribute("Scale", DoubleValue(35.0));
+            m_levArrivals->SetAttribute("Location", DoubleValue(28000.0));
+            m_levArrivals->SetAttribute("Scale", DoubleValue(4200.0));
+            break;
+        case ModelPresets::LOCKSTEP_UL:
+            m_initialSizeUniform->SetAttribute("Min", DoubleValue(0));
+            m_initialSizeUniform->SetAttribute("Max", DoubleValue(80));
+            m_endSizeUniform->SetAttribute("Min", DoubleValue(500));
+            m_endSizeUniform->SetAttribute("Max", DoubleValue(600));
+            m_levSizes->SetAttribute("Location", DoubleValue(92.0));
+            m_levSizes->SetAttribute("Scale", DoubleValue(38.0));
+            m_levArrivals->SetAttribute("Location", DoubleValue(22000.0));
+            m_levArrivals->SetAttribute("Scale", DoubleValue(3400.0));
+            break;
+        case ModelPresets::CUSTOM:
+        default:
+            break;
+        }
+    }
+}
+
+void
+RtaTigMobileGaming::DoStartApplication()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_socket->SetAllowBroadcast(true);
+    m_socket->ShutdownRecv();
+
+    m_currentStage = TrafficModelStage::INITIAL;
+
+    if (m_connected)
+    {
+        ScheduleNext();
+    }
+}
+
+void
+RtaTigMobileGaming::DoStopApplication()
+{
+    NS_LOG_FUNCTION(this);
+    m_currentStage = TrafficModelStage::ENDING;
+}
+
+void
+RtaTigMobileGaming::CancelEvents()
+{
+    NS_LOG_FUNCTION(this);
+    if (m_currentStage == TrafficModelStage::ENDING)
+    {
+        // handled once ending packet is transmitted
+        return;
+    }
+    m_txEvent.Cancel();
+}
+
+void
+RtaTigMobileGaming::ScheduleNext()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(!m_txEvent.IsPending());
+    const auto delay = MicroSeconds(m_levArrivals->GetValue());
+    m_txEvent = Simulator::Schedule(delay, &RtaTigMobileGaming::SendPacket, this);
+}
+
+void
+RtaTigMobileGaming::SendPacket()
+{
+    NS_LOG_FUNCTION(this);
+
+    uint32_t packetSize;
+    const auto stage{m_currentStage};
+    switch (stage)
+    {
+    case TrafficModelStage::INITIAL:
+        packetSize = m_initialSizeUniform->GetInteger();
+        break;
+    case TrafficModelStage::ENDING:
+        packetSize = m_endSizeUniform->GetInteger();
+        break;
+    case TrafficModelStage::GAMING:
+    default:
+        packetSize = std::round(m_levSizes->GetValue());
+        break;
+    }
+    auto packet = Create<Packet>(packetSize);
+
+    const auto actualSize = static_cast<uint32_t>(m_socket->Send(packet));
+    NS_ABORT_MSG_IF(actualSize != packetSize,
+                    "Sent size " << actualSize << " does not match expected size " << packetSize);
+    m_txTrace(packet);
+    m_txStageTrace(packet, stage);
+
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " gaming traffic source sent "
+                               << packetSize << " bytes during stage " << stage << " to "
+                               << InetSocketAddress::ConvertFrom(m_peer).GetIpv4() << " port "
+                               << InetSocketAddress::ConvertFrom(m_peer).GetPort());
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " gaming traffic source sent "
+                               << packetSize << " bytes during stage " << stage << " to "
+                               << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6() << " port "
+                               << Inet6SocketAddress::ConvertFrom(m_peer).GetPort());
+    }
+
+    if (m_currentStage == TrafficModelStage::ENDING)
+    {
+        m_currentStage = TrafficModelStage::INITIAL;
+        CancelEvents();
+        CloseSocket();
+    }
+    else
+    {
+        if (m_currentStage == TrafficModelStage::INITIAL)
+        {
+            m_currentStage = TrafficModelStage::GAMING;
+        }
+        ScheduleNext();
+    }
+}
+
+void
+RtaTigMobileGaming::DoConnectionSucceeded(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    ScheduleNext();
+}
+
+std::ostream&
+operator<<(std::ostream& os, RtaTigMobileGaming::TrafficModelStage stage)
+{
+    switch (stage)
+    {
+    case RtaTigMobileGaming::TrafficModelStage::INITIAL:
+        os << "Initial stage";
+        break;
+    case RtaTigMobileGaming::TrafficModelStage::GAMING:
+        os << "Gaming stage";
+        break;
+    case RtaTigMobileGaming::TrafficModelStage::ENDING:
+        os << "Ending stage";
+        break;
+    default:
+        NS_FATAL_ERROR("Unknown gaming traffic model stage");
+    }
+    return os;
+}
+
+} // Namespace ns3
